====== The Trac Ticket Workflow System ======

The Trac issue database provides a configurable workflow.

===== The Default Ticket Workflow =====

==== Environments upgraded from 0.10 ====

When you run "trac-admin &lt;env&gt; upgrade", your "trac.ini" will be modified to include a "[ticket-workflow]" section. The workflow configured in this case is the original workflow, so that ticket actions will behave like they did in 0.10.

Graphically, that looks like this:

[[/trac/chrome/site/../common/guide/original-workflow.png|{{/trac/chrome/site/../common/guide/original-workflow.png|original-workflow.png}}]]

There are some significant "warts" in this; such as accepting a ticket sets it to 'assigned' state, and assigning a ticket sets it to 'new' state. Perfectly obvious, right? So you will probably want to migrate to "basic" workflow; "contrib/workflow/migrate_original_to_basic.py" may be helpful.

==== Environments created with 0.11 ====

When a new environment is created, a default workflow is configured in your trac.ini. This workflow is the basic workflow (described in "basic-workflow.ini"), which is somewhat different from the workflow of the 0.10 releases.

Graphically, it looks like this:

[[/trac/chrome/site/../common/guide/basic-workflow.png|{{/trac/chrome/site/../common/guide/basic-workflow.png|basic-workflow.png}}]]

===== Additional Ticket Workflows =====

There are several example workflows provided in the Trac source tree; look in "contrib/workflow" for ".ini" config sections. One of those may be a good match for what you want. They can be pasted into the "[ticket-workflow]" section of your "trac.ini" file.

===== Basic Ticket Workflow Customization =====

Create a "[ticket-workflow]" section in "trac.ini". Within this section, each entry is an action that may be taken on a ticket. For example, consider the "accept" action from "simple-workflow.ini":

  accept = new,accepted -&gt; accepted
  accept.permissions = TICKET_MODIFY
  accept.operations = set_owner_to_self

The first line in this example defines the "accept" action, along with the states the action is valid in ("new" and "accepted"), and the new state of the ticket when the action is taken ("accepted"). The "accept.permissions" line specifies what permissions the user must have to use this action. The "accept.operations" line specifies changes that will be made to the ticket in addition to the status change when this action is taken. In this case, when a user clicks on "accept", the ticket owner field is updated to the logged in user. Multiple operations may be specified in a comma separated list.

The available operations are:

  * del_owner -- Clear the owner field.
  * set_owner -- Sets the owner to the selected or entered owner.
    * //actionname//".set_owner" may optionally be set to a comma delimited list or a single value.
  * set_owner_to_self -- Sets the owner to the logged in user.
  * del_resolution -- Clears the resolution field
  * set_resolution -- Sets the resolution to the selected value.
    * //actionname//".set_resolution" may optionally be set to a comma delimited list or a single value.
      Example:
      resolve_new = new -&gt; closed
      resolve_new.name = resolve
      resolve_new.operations = set_resolution
      resolve_new.permissions = TICKET_MODIFY
      resolve_new.set_resolution = invalid,wontfix
  * leave_status -- Displays "leave as &lt;current status&gt;" and makes no change to the ticket.

**Note:** Specifying conflicting operations (such as "set_owner" and "del_owner") has unspecified results.

  resolve_accepted = accepted -&gt; closed
  resolve_accepted.name = resolve
  resolve_accepted.permissions = TICKET_MODIFY
  resolve_accepted.operations = set_resolution

In this example, we see the ".name" attribute used. The action here is "resolve_accepted", but it will be presented to the user as "resolve".

For actions that should be available in all states, "*" may be used in place of the state. The obvious example is the "leave" action:

  leave = * -&gt; *
  leave.operations = leave_status
  leave.default = 1

This also shows the use of the ".default" attribute. This value is expected to be an integer, and the order in which the actions are displayed is determined by this value. The action with the highest ".default" value is listed first, and is selected by default. The rest of the actions are listed in order of decreasing ".default" values. If not specified for an action, ".default" is 0. The value may be negative.

There are a couple of hard-coded constraints to the workflow. In particular, tickets are created with status "new", and tickets are expected to have a "closed" state. Further, the default reports/queries treat any state other than "closed" as an open state.

While creating or modifying a ticket workfow, "contrib/workflow/workflow_parser.py" may be useful. It can create ".dot" files that [[http://www.graphviz.org|GraphViz]] understands to provide a visual description of the workflow.

This can be done as follows (your install path may be different).

  cd /var/local/trac_devel/contrib/workflow/
  sudo ./showworkflow /srv/trac/PlannerSuite/conf/trac.ini

And then open up the resulting "trac.pdf" file created by the script (it will be in the same directory as the "trac.ini" file).

After you have changed a workflow, you need to restart apache for the changes to take effect. This is important, because the changes will still show up when you run your script, but all the old workflow steps will still be there until the server is restarted.

===== Example: Adding optional Testing with Workflow =====

By adding the following to your [ticket-workflow] section of trac.ini you get optional testing. When the ticket is in new, accepted or needs_work status you can choose to submit it for testing. When it's in the testing status the user gets the option to reject it and send it back to needs_work, or pass the testing and send it along to closed. If they accept it then it gets automatically marked as closed and the resolution is set to fixed. Since all the old work flow remains, a ticket can skip this entire section.

  testing = new,accepted,needs_work -&gt; testing
  testing.name = Submit to reporter for testing
  testing.permissions = TICKET_MODIFY

  reject = testing -&gt; needs_work
  reject.name = Failed testing, return to developer

  pass = testing -&gt; closed
  pass.name = Passes Testing
  pass.operations = set_resolution
  pass.set_resolution = fixed

===== Example: Limit the resolution options for a new ticket =====

The above resolve_new operation allows you to set the possible resolutions for a new ticket. By modifying the existing resolve action and removing the new status from before the "-&gt;" we then get two resolve actions. One with limited resolutions for new tickets, and then the regular one once a ticket is accepted.

  resolve_new = new -&gt; closed
  resolve_new.name = resolve
  resolve_new.operations = set_resolution
  resolve_new.permissions = TICKET_MODIFY
  resolve_new.set_resolution = invalid,wontfix,duplicate

  resolve = assigned,accepted,reopened -&gt; closed
  resolve.operations = set_resolution
  resolve.permissions = TICKET_MODIFY

===== Advanced Ticket Workflow Customization =====

If the customization above is not extensive enough for your needs, you can extend the workflow using plugins. These plugins can provide additional operations for the workflow (like code_review), or implement side-effects for an action (such as triggering a build) that may not be merely simple state changes. Look at [[http://trac.edgewall.org/intertrac/source%3Atrunk/sample-plugins/workflow|sample-plugins/workflow]] for a few simple examples to get started.

But if even that is not enough, you can disable the ConfigurableTicketWorkflow component and create a plugin that completely replaces it.

===== some ideas for next steps =====

New enhancement ideas for the workflow system should be filed as enhancement tickets against the "ticket system" component. If desired, add a single-line link to that ticket here.

If you have a response to the comments below, create an enhancement ticket, and replace the description below with a link to the ticket.

  * the "operation" could be on the nodes, possible operations are:
    * **preops**: automatic, before entering the state/activity
    * **postops**: automatic, when leaving the state/activity
    * **actions**: can be chosen by the owner in the list at the bottom, and/or drop-down/pop-up together with the default actions of leaving the node on one of the arrows.

This appears to add complexity without adding functionality; please provide a detailed example where these additions allow something currently impossible to implement.

  * operations could be anything: sum up the time used for the activity, or just write some statistical fields like

A workflow plugin can add an arbitrary workflow operation, so this is already possible.

  * set_actor should be an operation allowing to set the owner, e.g. as a "preop":
    * either to a role, a person
    * entered fix at define time, or at run time, e.g. out of a field, or select.

This is either duplicating the existing "set_owner" operation, or needs to be clarified.

  * Actions should be selectable based on the ticket type (different Workflows for different tickets)

This is becoming a frequent request, with clear usecases. The closest the current implementation will allow is to have a plugin provide a "triage" action that sets the next state based on the ticket type, so a "new" ticket would move to "new_task", "new_defect", etc., and the workflow graph would separate at that point.
